#include "SFML/Graphics.hpp"
#include "SFML/Window.hpp"
#include "SFML/System.hpp"

#include <SFML/Audio.hpp>

#include "string.h"


char VARI[100];
std::string CADENAStr;

#define PANX 800
#define PANY 600

#define SCAPE	-1
#define KLEFT 	1
#define KRIGHT	2
#define KUP		3
#define KDOWN	4
#define KDISPARO 5

#define ASTEVELO 10

int naveX = 100, naveY = 530, inaveX = 10, inaveY = 10;

struct ESTRELLAS {    int x;    int y;    int v;    int c; };
struct ESTRELLAS estrellasm[30];

struct ASTEROIDES {    int x;    int y;    int v; int vy;   int t;};
struct ASTEROIDES asteroidesm[5];

struct MISIL {  int x;    int y;    int v;    int s;};
struct MISIL misilm0;

int tiempo,tiempo1,tiempoD;
int asteN;

int vidas;

//sf::RenderWindow ventana(sf::VideoMode(PANX, PANY), "CINTURON DE ASTEROIDES", sf::Style::Close);  // VENTANA 
sf::RenderWindow ventana(sf::VideoMode(PANX, PANY), "CINTURON DE ASTEROIDES", sf::Style::Close | sf::Style::Fullscreen); //PANTALLA COMPLETA

sf::Text miTexto;
sf::Font font;

void intro (void);

int screenWidth,screenHeight ;

int main(int argc,char *argv[])
{
    int tecla;
    int x, y,z,zz;    
    
    screenWidth = sf::VideoMode::getDesktopMode().width;
	screenHeight = sf::VideoMode::getDesktopMode().height;
	printf("PANTALLA %dx%d\n",screenWidth,screenHeight );
	sf::View view1(sf::FloatRect(0.f, 0.f, (float)PANX, (float)PANY));
	ventana.setView(view1);

	ventana.setFramerateLimit(30);
    ventana.setMouseCursorVisible(false);
    ventana.setKeyRepeatEnabled(false);
    ventana.clear(sf::Color::White);
	ventana.display();	
	
    
    if (!font.loadFromFile("sansation.ttf")){
		printf("¡FUENTES NO ENCONTRADAS!");
		return false;
	}

    sf::Texture textura;
    if (!textura.loadFromFile("sprites.png")) {
		printf("nave.png no encontrado\n");
		return false;
    }
   
    sf::Music musica;
	if (!musica.openFromFile("intro.ogg")){
		printf("intro.ogg no encontrado\n");
		return false;
		}

	sf::SoundBuffer bufferSound1;
    if (!bufferSound1.loadFromFile("sound1.wav")){
		printf("sound1.wav no encontrado\n");
		return false;
		}
	sf::Sound sonido1;
	sonido1.setBuffer(bufferSound1);
	
	sf::SoundBuffer bufferSound2;
    if (!bufferSound2.loadFromFile("sound2.wav")){
		printf("sound2.wav no encontrado\n");
		return false;
		}
	sf::Sound sonido2;
	sonido2.setBuffer(bufferSound2);
	
	sf::SoundBuffer bufferSound3;
    if (!bufferSound3.loadFromFile("sound3.wav")){
		printf("sound3.wav no encontrado\n");
		return false;
		}
	sf::Sound sonido3;
	sonido3.setBuffer(bufferSound3);
		
    sf::Sprite nave { textura};
    nave.setTextureRect( {	0, 0, 64, 64}  );
    sf::Sprite asteN0 {textura};
    asteN0.setTextureRect( {64, 0, 64, 64}  );
    sf::Sprite asteN1 {textura};
    asteN1.setTextureRect( {128, 0, 64, 64}  );
    sf::Sprite asteN2 {textura};
    asteN2.setTextureRect( {192, 0, 64, 64}  );
    sf::Sprite asteN3 {textura};
    asteN3.setTextureRect( {256, 0, 64, 64}  );
    sf::Sprite asteN4 {textura};
    asteN4.setTextureRect( {320, 0, 64, 64}  );   
    sf::Sprite asteN5 {textura};
    asteN5.setTextureRect( {384, 0, 64, 64}  );
        
    sf::Sprite misil {textura};
    misil.setTextureRect( {576, 32, 6, 32}  );
    
    sf::Sprite vidaS {textura};
    vidaS.setTextureRect( {576, 0, 32, 32}  );
    
    sf::Sprite explosion {textura};
    explosion.setTextureRect( {512, 0, 64, 64}  );
    sf::Sprite explosion1 {textura};
    explosion1.setTextureRect( {448, 0, 64, 64}  );

    sf::Texture cielo;
    if (!cielo.loadFromFile("cielo.jpg")) { 
		printf("cielo.jpg no encontrado\n");
		return false;
    }
    
    sf::Sprite cieloS { cielo};
    
//Inicializando  colores y estrellas
		sf::Vertex estrella[1];
		sf::Color colorS[5];
		colorS[0] = { 0xFF, 0, 0, 255 };
		colorS[1] = { 0, 0, 255, 255 };
		colorS[2] = { 0xf8, 0x96, 0x9d, 255 };
		colorS[3] = { 0xf9, 0xf9, 0x08, 255 };
		colorS[4] = sf::Color::White;

		sf::Event evento;
		
InicioV:
		vidas=3;
		tiempo=30;
		tiempo1=0;
		asteN=0;
		musica.stop();
		musica.play();
		ventana.clear(sf::Color::Black);
		ventana.display();		
		intro();
Inicio:		
		ventana.clear(sf::Color::Black);
		ventana.draw(cieloS);
		
		CADENAStr = "ASTEROIDES SFML";			
		miTexto.setFont(font);
		miTexto.setString(CADENAStr);
		miTexto.setFillColor(sf::Color::Yellow);
	    miTexto.setOutlineColor(sf::Color {  0x8ECF3CFF} );
	    miTexto.setOutlineThickness(5.f);
	    miTexto.setCharacterSize(60);
	    miTexto.setPosition(130, 130);
	    ventana.draw(miTexto);

		ventana.display();					
		sf::sleep(sf::milliseconds(2000));
		
		//Inicializando Texto
		CADENAStr = "SPACE para jugar";			
		miTexto.setString(CADENAStr);
		miTexto.setFillColor(sf::Color::Red);
		miTexto.setOutlineThickness(0.f);
		miTexto.setCharacterSize(40);
		miTexto.setPosition(230,400);
		ventana.draw(miTexto);
		ventana.display();			
		
		while (ventana.isOpen()) {
			while (ventana.pollEvent(evento)) 
			{
				if (evento.type == sf::Event::Closed) {
					printf("Cerrando ventana SFML\n");
					ventana.close();
				}
			if (sf::Keyboard::isKeyPressed(sf::Keyboard::Space))	goto juego1;
			ventana.display();
			}
		}
	
juego1:						
	musica.stop();	
			
	naveX = 470; naveY = 530;
    for (x = 1; x < 30; x++) {
		estrellasm[x].y = 0;
		estrellasm[x].x = rand() % PANX;
		estrellasm[x].v = rand() % 5;
		estrellasm[x].c = 2+rand() % 5;
    }

	for (x = 0; x < 5; x++) {
		asteroidesm[x].y = 0;
		asteroidesm[x].x = rand() % PANX;
		asteroidesm[x].v = 3 + rand() % ASTEVELO;
		asteroidesm[x].t = rand() % 4;
    }
    
	misilm0.v = 10;
	misilm0.s = 0;
	
//	miTexto.setCharacterSize(20);

    while (ventana.isOpen()) {
		tiempo++;
		tiempoD++;
		if(tiempo>29)
			{
				tiempo=0; tiempo1++;
				CADENAStr = "TIME " + std::to_string(tiempo1) +"   ASTE." + std::to_string(asteN);
				miTexto.setString(CADENAStr);
				miTexto.setPosition(2, 2);				
			}
		while (ventana.pollEvent(evento)) {
			if (evento.type == sf::Event::Closed) {
			printf("Cerrando ventana SFML\n");
			ventana.close();
			}

			tecla = 0;
			if (sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
			tecla = KLEFT;
			else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
			tecla = KRIGHT;
			else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
			tecla = KUP;
			else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
			tecla = KDOWN;
			else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Escape))
			tecla = SCAPE;
			else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Space))
			tecla = KDISPARO;
		}

		switch (tecla) {
		case KLEFT:
			naveX -= inaveX;
			if (naveX < 0)
			naveX = 0;
			break;
		case KRIGHT:
			naveX += inaveX;
			if (naveX > 736)
			naveX = 736;
			break;
		case KDOWN:
			naveY += inaveY;
			if (naveY > 536)
			naveY = 536;
			break;
		case KUP:
			naveY -= inaveY;
			if (naveY < 0)
			naveY = 0;
			break;
		case KDISPARO:
			if(tiempoD>30)
			{
				sonido2.play();
				misilm0.s=1;
				misilm0.x=naveX+29;
				misilm0.y=naveY;
				tiempoD=0;
			}
			break;
		case SCAPE:
			ventana.close();
			break;
		}

//__Detectar colisiones misil______  
	if(misilm0.s==1)
		for (x = 0; x < 5; x++) 
		{
			if (asteroidesm[x].y < misilm0.y+32 && asteroidesm[x].y +64 > misilm0.y)			
				if (asteroidesm[x].x < misilm0.x+8 && asteroidesm[x].x +64 > misilm0.x)
				{
					sonido3.play();
					explosion.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(explosion);
					ventana.display();
					asteroidesm[x].y=1000;
					misilm0.s=0;
					asteN++;		
				}			
		}	

//__Detectar colisiones nave______                   
		for (x = 0; x < 5; x++) 
		{
			if (asteroidesm[x].y+10 < naveY+54 && asteroidesm[x].y +54 > naveY+10)			
				if (asteroidesm[x].x+10 < naveX+54 && asteroidesm[x].x +54 > naveX+10)
				{
					explosion.setPosition( {(float) naveX, (float)naveY});
					explosion1.setPosition( {(float) naveX, (float)naveY});
					sonido1.play();
					for (z = 0; z < 15; z++) 
						{
						ventana.draw(explosion);
						ventana.display();
						sf::sleep(sf::milliseconds(100));
						ventana.draw(explosion1);
						ventana.display();
						sf::sleep(sf::milliseconds(100));
						}
					sf::sleep(sf::milliseconds(2000));
					vidas--;
					if(vidas==0) goto InicioV;	
					goto Inicio;
				}			
		}	

		ventana.clear(sf::Color::Black);
		ventana.draw(cieloS);			
//__MISIL___________________
				misilm0.y -= misilm0.v;
				if (misilm0.y < -60) misilm0.s = 0;
				if (misilm0.s==1)
				{
					 misil.setPosition( {(float) misilm0.x, (float) misilm0.y});
					 ventana.draw(misil);
				}

//__Movimiento asteroides_____                   
		for (x = 0; x < 5; x++) {
			asteroidesm[x].y += asteroidesm[x].v;
			asteroidesm[x].x += asteroidesm[x].vy;
			if (asteroidesm[x].y > PANY) {
				asteroidesm[x].y = -64;
				asteroidesm[x].x = rand() % 770;
				asteroidesm[x].t = rand() % 6;
				asteroidesm[x].v = 3 + rand() % ASTEVELO;
				if(asteroidesm[x].t==5) asteroidesm[x].v = 3 + rand() % (ASTEVELO*2);
				asteroidesm[x].vy = -5 + rand() % 9;
			}
			switch(asteroidesm[x].t)
			{
				case 0:
					asteN0.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN0);
				break;
				case 1:
					asteN1.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN1);				
				break;
				case 2:
					asteN2.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN2);				
				break;
				case 3:
					asteN3.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN3);				
				break;
				case 4:
					asteN4.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN4);				
				break;
				case 5:
					asteN5.setPosition( {(float) asteroidesm[x].x, (float) asteroidesm[x].y});
					ventana.draw(asteN5);				
				break;
			}			
		}		
				
	//__Movimiento estrellas_____                   
		for (x = 1; x < 30; x++) {
			estrellasm[x].y = estrellasm[x].y + estrellasm[x].v;
			if (estrellasm[x].y > 630) {
				estrellasm[x].y = 0;
				estrellasm[x].x = rand() % 770;
				estrellasm[x].v = rand() % 10;
			}
			if (estrellasm[x].v < 1) 	estrellasm[x].v = rand() % 5;
			estrella[0] = { sf::Vector2f(estrellasm[x].x, estrellasm[x].y), colorS[estrellasm[x].c] };
			ventana.draw(&estrella[0], 1, sf::Points);
		}
		
	//__Movimiento estrellas_____                   
		for (x = vidas; x > 0; x--) {
			vidaS.setPosition( {(float) 668+x*33, (float) 1});
			ventana.draw(vidaS);			
		}


		nave.setPosition( {	 (float) naveX, (float) naveY});
		ventana.draw(nave);
		ventana.draw(miTexto);
		ventana.display();
	}
	
	
}


void intro(void) {
	int z, zz;
#define NUM_STR 7
	ventana.clear(sf::Color::Black);
	miTexto.setFillColor(sf::Color::Red);
	miTexto.setOutlineThickness(0.f);
	miTexto.setCharacterSize(20);
	miTexto.setFont(font);
   std::string introL[NUM_STR];
	introL[0] = ("En el centro del sistema solar se encuentra");
	introL[1] = ("el cinturon de asteroides.");
	introL[2] = ("Tiene muy poca masa, 4% de la masa lunar.");
	introL[3] = ("Hemos tenido mala suerte, debemos atravesarlo  ");
	introL[4] = ("por la zona de masa densa.");
	introL[5] = ("Suerte.                   ");
	introL[6] = ("El arma tarda en recargarse 1 segundo .           ");

	ventana.clear(sf::Color::Black);
	for (zz = 0; zz < NUM_STR; zz++) {
		miTexto.setPosition(200, 200 + zz * 25);
		for (z = 0; z <= introL[zz].length(); z++) {
			CADENAStr = introL[zz].substr(0, z);
			miTexto.setString(CADENAStr);
			ventana.draw(miTexto);
			ventana.display();
			
		}
	}
	sf::sleep(sf::milliseconds(2000));
}

